<template>
  <div>
    <el-select
      v-model="currValue"
      filterable
      remote
      @change="changeValue"
      :disabled="isDisabled"
      placeholder="请输入"
      :remote-method="remoteMethod"
      clearable
      :loading="selectLoading"
      class="lmes-select"
    >
      <el-option
        v-if="data.length > 0"
        class="lmes-select-head"
        key="title1"
        label="title"
        value="title"
        disabled
      >
        <span v-for="(col, j) in columns" :key="col.prop">{{ col.label }}</span>
      </el-option>
      <el-option
        class="lmes-select-body"
        v-for="(item, i) in data"
        :key="'SearchSelect-' + i"
        :label="formatter(item)"
        :value="item[valueColumn]"
      >
        <span v-for="(col, j) in columns" :key="col.prop + i">{{
          col.formatter
            ? col.formatter(item[col.prop])
            : item[col.prop]
            ? item[col.prop]
            : '--'
        }}</span>
      </el-option>
    </el-select>
  </div>
</template>

<script>
export default {
  data() {
    return {
      currValue: null
    }
  },
  props: {
    value: null,
    columns: {
      type: Array,
      default: () => {
        return []
      }
    },
    data: {
      type: Array,
      default: () => {
        return []
      }
    },
    formatter: {
      type: Function
    },
    isDisabled: {
      type: Boolean,
      default: () => {
        return false
      }
    },
    selectLoading: {
      type: Boolean,
      default: () => {
        return false
      }
    },
    valueColumn: {
      type: String,
      default: () => {
        return 'id'
      }
    }
  },
  mounted() {},
  methods: {
    changeValue() {
      this.$emit('input', this.currValue)
      this.$emit('selectChange')
    },
    remoteMethod(query) {
      this.$emit('remoteSearch', query)
    }
  },
  watch: {
    value() {
      this.currValue = this.value
    }
  }
}
</script>

<style>
.lmes-select {
  width: 100%;
}

.lmes-select-nodata {
  text-align: center;
  font-size: 13px;
  line-height: 44px;
}

.lmes-select-head span,
.lmes-select-body span {
  display: inline-block;
  width: 150px;
  font-size: 13px;
  padding: 0 10px !important;
}

.lmes-select-head,
.lmes-select-body,
.lmes-select-nodata {
  padding-left: 10px !important;
  padding-right: 10px !important;
}

.lmes-select-head span:last-child,
.lmes-select-body span:last-child {
  /*min-width: 100px;*/
  text-align: right;
}

.lmes-select .el-input .el-input__inner {
  background: transparent !important;
  border-top: none;
  border-left: none;
  border-right: none;
  padding: 0;
}
</style>
